
/* touch panel interface define */
sbit SDA	   =    P3^0;
sbit SCL       =    P3^1;
sbit PEN_INT       =    P3^2;	
sbit RESET	   =	P3^3;


//Touch Status	 
#define Key_Down 0x01
#define Key_Up   0x00 


struct _ts_event
{
    uint    x1;
    uint    y1;
    uint    x2;
    uint    y2;
    uint    x3;
    uint    y3;
    uint    x4;
    uint    y4;
    uint    x5;
    uint    y5;
    uchar     touch_pressure;	
    uchar     touch_point;
	uchar     Key_Sta;	
};

struct _ts_event ts_event; 

#define WRITE_ADD	0x34 
#define READ_ADD	0x35

#define CT_MAX_TOUCH    5		//ݴֵ֧ĵ

// Registers define

#define HYN_REG_MUT_DEBUG_INFO_MODE             0xD101
#define HYN_REG_MUT_RESET_MODE            		0xD102
#define HYN_REG_MUT_DEEP_SLEEP_MODE    			0xD105
#define HYN_REG_MUT_NORMAL_MODE                0xD109



#define HYN_REG_MUT_DEBUG_INFO_IC_CHECKSUM             0xD208
#define HYN_REG_MUT_DEBUG_INFO_FW_VERSION              0xD204
#define HYN_REG_MUT_DEBUG_INFO_RES_Y            	   0xD1FA
#define HYN_REG_MUT_DEBUG_INFO_RES_X            	   0xD1F8
#define GTP_READ_COOR_ADDR    0xD000





 uchar code GTP_CFG_DATA[]=
{ 
0x5A,0x20,0x03,0x58,0x02,0x05,0x0D,0x00,
0x01,0x0A,0x28,0x0F,0x50,0x32,0x03,0x05,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x8C,0x2E,0x0E,0x3C,0x3E,
0xD3,0x07,0x00,0x00,0x01,0x00,0x03,0x1D,
0x00,0x01,0x00,0x00,0x00,0x03,0x64,0x32,
0x00,0x00,0x00,0x32,0x82,0x94,0xC5,0x02,
0x08,0x00,0x00,0x04,0x8A,0x37,0x00,0x75,
0x42,0x00,0x62,0x50,0x00,0x52,0x62,0x00,
0x46,0x76,0x00,0x46,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x02,0x04,0x06,0x08,0x0A,0x0C,0x0E,0x10,
0x12,0x14,0x16,0x18,0x1A,0x1C,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,
0x04,0x06,0x08,0x0A,0x0C,0x0F,0x10,0x12,
0x13,0x14,0x16,0x18,0x1C,0x1D,0x1E,0x1F,
0x20,0x21,0x22,0x24,0x26,0x28,0x29,0x2A,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x59,0x01


};


void TOUCH_Init(void);
void TOUCH_Start(void);
void TOUCH_Stop(void);
uchar   TOUCH_Wait_Ack(void);
void TOUCH_Ack(void);
void TOUCH_NAck(void);

void TOUCH_Send_Byte(uchar txd);
uchar TOUCH_Read_Byte(unsigned char ack);
void Draw_Big_Point(uint x,uint y,uint colour);
uchar CST340_read_data(void);
void inttostr(uint value,uchar *str);


//IIC start
void TOUCH_Start(void)
{ 
	SDA=1;  
	_nop_();
	SCL=1;
	delay_us(3);
	SDA=0;  
	delay_us(3);
	SCL=0;
//	delay_us(1);
}	  


//IIC stop
void TOUCH_Stop(void)
{
	SDA=0;
	_nop_();
	SCL=1;
	delay_us(3);
	SDA=1;
	delay_us(3);
	SCL=0;
//	delay_us(1);						   	
}


//Wait for an answer signal
uchar TOUCH_Wait_Ack(void)
{	uchar errtime=0;

	SDA=1;
//	delay_us(1);
	SCL=1;
//	delay_us(1);
  	while(SDA)
	{
	    errtime++;
	    if(errtime>250)
		    {
		      TOUCH_Stop();
		      return 1;
		    }	
	
	   ;
	}
	SCL=0;
//	delay_us(1);
	return 0;
}



//Acknowledge
void TOUCH_Ack(void)
{	SCL=0;
	_nop_();
	SDA=0;
	delay_us(2);
	SCL=1;
	delay_us(2);
	SCL=0;
	_nop_();
}



//NO Acknowledge		    
void TOUCH_NAck(void)
{	SCL=0;
	delay_us(1);
	SDA=1;
	delay_us(2);
	SCL=1;
	delay_us(2);
	SCL=0;
	_nop_();
}	
	

//IIC send one byte		  
void TOUCH_Send_Byte(uchar Byte)
{	uchar t;  		
 	SCL=0; 
//	delay_us(5);
    for(t=0;t<8;t++)
    {           
	   	SDA=(bit)(Byte & 0x80) ;
	   	Byte <<=1;
		delay_us(2);
	   	SCL=1;
		delay_us(2);
	   	SCL=0;
	//	delay_us(5);
    }	

} 

//Read one byteack=0Send Acknowledgeack=1NO Acknowledge   
uchar TOUCH_Read_Byte(uchar ack)
{	uchar t,receive=0;

	SCL=0;
//	delay_us(5);
	SDA=1;
//	delay_us(5);
	for(t = 0; t < 8; t++)
	{	_nop_();
	 	SCL = 0;
		delay_us(4);
	 	SCL=1;
		delay_us(4);
	 	receive<<=1;
	 	if(SDA)receive=receive|0x01;
	//	delay_us(5);
	}

					 
   	if (ack)  TOUCH_NAck();//NO Acknowledge 
   	else       TOUCH_Ack(); //Send Acknowledge   
    
	 return receive;
}

uchar CST340_WR_Reg(uint reg,uchar *buf,uchar len)
{
	uchar i;
	uchar ret=0;
	TOUCH_Start();	
 	TOUCH_Send_Byte(WRITE_ADD);   	//д 	 
	TOUCH_Wait_Ack();
	TOUCH_Send_Byte(reg>>8);   	//͸8λַ
	TOUCH_Wait_Ack();	 										  		   
	TOUCH_Send_Byte(reg&0XFF);   	//͵8λַ
	TOUCH_Wait_Ack(); 
	for(i=0;i<len;i++)
	{	   
    	TOUCH_Send_Byte(buf[i]);  	//
		ret=TOUCH_Wait_Ack();
		if(ret)break;  
	}
    TOUCH_Stop();					//һֹͣ	    
	return ret; 
}


void CST340_RD_Reg(uint reg,uchar *buf,uchar len)
{
	uchar i;
 	TOUCH_Start();	
 	TOUCH_Send_Byte(WRITE_ADD);   	//д 	 
	TOUCH_Wait_Ack(); 
 	TOUCH_Send_Byte(reg>>8);   	//͸8λַ
	TOUCH_Wait_Ack();  										  		   
 	TOUCH_Send_Byte(reg&0XFF);   	//͵8λַ
	TOUCH_Wait_Ack();
  
 	TOUCH_Start(); 	 	   
	TOUCH_Send_Byte(READ_ADD);    //Ͷ		   
	TOUCH_Wait_Ack();    
	for(i=0;i<len;i++)
	{	   
    	buf[i]=TOUCH_Read_Byte(i==(len-1)?1:0); //
		
		
	//	if(i==(len-1))  buf[i]=TOUCH_Read_Byte(1);
	//	else            buf[i]=TOUCH_Read_Byte(0);	 
		
	} 
     TOUCH_Stop();//һֹͣ	    
}




uchar CST340_read_data(void)
{	uchar buf[30] = {0xff}; uchar ret = 0;uchar ss[4];	


	CST340_RD_Reg(GTP_READ_COOR_ADDR,buf,28);		
	 ss[0]=0;
     CST340_WR_Reg(GTP_READ_COOR_ADDR ,ss,1);
 
  	ts_event.touch_point = buf[5]&0x0F; 
	ts_event.touch_pressure= buf[4];

 /* 	inttostr(ts_event.touch_point ,ss);	

		Goto_Text_XY(20,250);
		Show_String("touch_point=");

		Text_Mode();
		LCD_CmdWrite(0x04);	
		LCD_DataWrite(ss[0]);	delay_us(2);	
		LCD_DataWrite(ss[1]);	delay_us(2);
		LCD_DataWrite(ss[2]);	delay_us(2);
		LCD_DataWrite(ss[3]);	delay_us(2);


   	inttostr(ts_event.touch_pressure ,ss);	
   		Goto_Text_XY(20,280);
		Show_String("pressure=");
		Text_Mode();
		LCD_CmdWrite(0x04);	
		LCD_DataWrite(ss[0]);	delay_us(2);	
		LCD_DataWrite(ss[1]);	delay_us(2);
		LCD_DataWrite(ss[2]);	delay_us(2);
		LCD_DataWrite(ss[3]);	delay_us(2);		
			 									  */

  	if (ts_event.touch_point == 0) 
		{  			

			return 0;
  		}		
   

					switch (ts_event.touch_point) 
					{
 						
							case 5:
				           			ts_event.x5 = (uint)(buf[23] )<<4 | (uint)buf[25]>>4&0x0F;;
				           			ts_event.y5 = (uint)(buf[24] )<<4 | (uint)buf[25]&0x0F;
				
						    case 4:
						           	ts_event.x4 = (uint)(buf[18] )<<4 | (uint)buf[20]>>4&0x0F;;
						           	ts_event.y4 = (uint)(buf[19] )<<4 | (uint)buf[20]&0x0F;
						
						    case 3:
						           	ts_event.x3 = (uint)(buf[13] )<<4 | (uint)buf[15]>>4&0x0F;;
						           	ts_event.y3 = (uint)(buf[14] )<<4 | (uint)buf[15]&0x0F;
						
						    case 2:
						           	ts_event.x2 = (uint)(buf[8] )<<4 | (uint)buf[10]>>4&0x0F;;
						           	ts_event.y2 = (uint)(buf[9] )<<4 | (uint)buf[10]&0x0F;
						
						    case 1:
						           	ts_event.x1 = (uint)(buf[1])<<4 | (uint)buf[3]>>4&0x0F;;
						           	ts_event.y1 = (uint)(buf[2])<<4 | (uint)buf[3]&0x0F;
				
				            break;
						    default:
						    return 0;
					}


	   
	return ret;
}


void inttostr(uint value,uchar *str)
{
	str[0]=value/1000+48;
	str[1]=value%1000/100+48;
	str[2]=value%1000%100/10+48;
 	str[3]=value%1000%100%10+48;
}



void TOUCH_Init(void)
{	
	
    	CST340_WR_Reg(HYN_REG_MUT_RESET_MODE,0 ,0);	  

 		RESET=0;						   
		delay_ms(50);
 		RESET=1;
		delay_ms(50);

    	CST340_WR_Reg(HYN_REG_MUT_NORMAL_MODE ,0 ,0);	
	
		ts_event.x1=0;
		ts_event.y1=0;
		ts_event.x2=0;
		ts_event.y2=0;
		ts_event.x3=0;
		ts_event.y3=0;
		ts_event.x4=0;
		ts_event.y4=0;
		ts_event.x5=0;
		ts_event.y5=0;
    	ts_event.Key_Sta=Key_Up;

	   
}	

void LCD_DrawCircle_Fill
(
 unsigned short XCenter         
,unsigned short YCenter           
,unsigned short R                
,unsigned long ForegroundColor 
)
{
	Foreground_color_65k(ForegroundColor);
	Circle_Center_XY(XCenter,YCenter);
  Circle_Radius_R(R);
  Start_Circle_or_Ellipse_Fill();
  Check_2D_Busy(); 
}


void TPTEST(void)
{uchar ss[10]; uchar re=0;  
  
   Select_Main_Window_16bpp();
	Main_Image_Start_Address(0);				
	Main_Image_Width(LCD_XSIZE_TFT);							
	Main_Window_Start_XY(0,0);

	Canvas_Image_Start_address(0);//Layer 1
	Canvas_image_width(LCD_XSIZE_TFT);//
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_XSIZE_TFT,LCD_YSIZE_TFT);

 	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_XSIZE_TFT,LCD_YSIZE_TFT);
	Start_Square_Fill();
  	delay_ms(100);

 ///////////////////////////Square
	Foreground_color_65k(Red);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_XSIZE_TFT-1,LCD_YSIZE_TFT-1);
	Start_Square();
  	delay_ms(100);

	Foreground_color_65k(Red);
	Background_color_65k(Black);
	CGROM_Select_Internal_CGROM();
	Font_Select_8x16_16x16();

	TOUCH_Init();


 	
	Foreground_color_65k(White);
	Background_color_65k(Black);

		Font_Select_8x16_16x16();
		Goto_Text_XY(10,100);	
		Show_String("Capacitive touch screen test");
		Goto_Text_XY(LCD_XSIZE_TFT-48,LCD_YSIZE_TFT-20);
		Show_String("Clear");   
		Goto_Text_XY(15,LCD_YSIZE_TFT-20);
		Show_String("Exit");

 	while(next)
	{	   
	    if(PEN_INT==0)
			{
					CST340_read_data();
					ts_event.Key_Sta=Key_Up;
				
				if ((ts_event.x1<85) &&(ts_event.y1>920))return;// flag=0; 
            	if ((ts_event.x1>322) &&(ts_event.y1>920))
              	{ 
				  	Foreground_color_65k(Black);
					Line_Start_XY(0,0);
					Line_End_XY(LCD_XSIZE_TFT,LCD_YSIZE_TFT);
					Start_Square_Fill();
					  	delay_ms(100);
				 	Foreground_color_65k(Red);
					Line_Start_XY(0,0);
					Line_End_XY(LCD_XSIZE_TFT-1,LCD_YSIZE_TFT-1);
					Start_Square();
					  	delay_ms(100);
					Foreground_color_65k(White);
					Background_color_65k(Black);
					CGROM_Select_Internal_CGROM();
					Font_Select_8x16_16x16();
					Goto_Text_XY(40,200);
					Show_String("Capacitive touch screen test");
					Goto_Text_XY(LCD_XSIZE_TFT-48,LCD_YSIZE_TFT-20);
					Show_String("Clear");   
					Goto_Text_XY(15,LCD_YSIZE_TFT-20);
					Show_String("Exit");
              	} 
				   


			/*		inttostr(ts_event.x1,ss);	

					Foreground_color_65k(White);
					Background_color_65k(Black);
					CGROM_Select_Internal_CGROM();
					Font_Select_8x16_16x16();
					Goto_Text_XY(100,60);
					Show_String("X = ");	

					Text_Mode();
					LCD_CmdWrite(0x04);							
				  	LCD_DataWrite(ss[0]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[1]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[2]);
					//Delay1ms(1);
 				  	LCD_DataWrite(ss[3]);	 

					inttostr(ts_event.y1,ss);
					Goto_Text_XY(100,140);   //Set the display position
					Show_String("Y = ");	
					Text_Mode();
					LCD_CmdWrite(0x04);	
				  	LCD_DataWrite(ss[0]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[1]);
					//Delay1ms(1);
				  	LCD_DataWrite(ss[2]);
					//Delay1ms(1);
 				  	LCD_DataWrite(ss[3]); */


					if(ts_event.touch_point == 1)	{LCD_DrawCircle_Fill(ts_event.x1,ts_event.y1,ts_event.touch_pressure/12,Red);}

					if(ts_event.touch_point == 2)	{LCD_DrawCircle_Fill(ts_event.x1,ts_event.y1,2,Red);
													 LCD_DrawCircle_Fill(ts_event.x2,ts_event.y2,2,Green);}
													 	
					if(ts_event.touch_point == 3)	{LCD_DrawCircle_Fill(ts_event.x1,ts_event.y1,2,Red);
													 LCD_DrawCircle_Fill(ts_event.x2,ts_event.y2,2,Green);
													 LCD_DrawCircle_Fill(ts_event.x3,ts_event.y3,2,Blue);}

					if(ts_event.touch_point == 4)	{LCD_DrawCircle_Fill(ts_event.x1,ts_event.y1,2,Red);
													 LCD_DrawCircle_Fill(ts_event.x2,ts_event.y2,2,Green);
													 LCD_DrawCircle_Fill(ts_event.x3,ts_event.y3,2,Blue);
													 LCD_DrawCircle_Fill(ts_event.x4,ts_event.y4,2,Cyan);}	

					if(ts_event.touch_point == 5)	{LCD_DrawCircle_Fill(ts_event.x1,ts_event.y1,2,Red);
													 LCD_DrawCircle_Fill(ts_event.x2,ts_event.y2,2,Green);
													 LCD_DrawCircle_Fill(ts_event.x3,ts_event.y3,2,Blue);
													 LCD_DrawCircle_Fill(ts_event.x4,ts_event.y4,2,Cyan);
													 LCD_DrawCircle_Fill(ts_event.x5,ts_event.y5,2,Magenta);}

			
			}	



    }
   	
  
      
}


				